import { connect } from "react-redux"
import { actionFullSubscribe, actionFullUnSubscribe, backendURL } from "../../actions"
import CUserPosts from "./UserPosts";


const FollowButton = ({aboutMe={},onSubscribe,onUnSubscribe,props})=> {
       if(aboutMe._id === props){
           return <></>
       }
        let followed = (aboutMe.following || []).some(item => item._id === props)
        return(
            <>
            {followed !== true ? (
                <button className="bg-fuchsia-600 px-2 py-1 text-white font-semibold text-sm rounded block text-center sm:inline-block" onClick={()=>onSubscribe(aboutMe._id,props)}>Follow</button>
            ):(
                <button className="bg-fuchsia-600 px-2 py-1 text-white font-semibold text-sm rounded block text-center sm:inline-block" onClick={()=>onUnSubscribe(aboutMe._id,props)}>UnFollow</button>
            )}
            
            </>
        )
}

const CFollowButton = connect(state=>({aboutMe: state.promise.aboutMe?.payload || {}}),{onSubscribe: actionFullSubscribe, onUnSubscribe: actionFullUnSubscribe})(FollowButton)


const UserItem = ({aboutUser = {}}) =>{
        /* console.log(aboutUser.followers.length); */
    return(
        <div>
            <div className="flex flex-wrap items-center p-4 md:py-8">
                <div className="md:w-3/12">
                <img src={aboutUser?.avatar?.url ?`${backendURL}/${aboutUser.avatar.url} `: "nothing"} alt="avatar" className="h-20 w-20 md:w-40 md:h-40 lg:w-60 lg:h-60 object-cover rounded-full"/>
                </div>
                <div className="w-8/12 md:w-7/12 m-4">
                <div className="md:flex md:flex-wrap md:items-center">
                    <h2 className="text-3x1 inline-block font-light mr-0.5  sm:mb-0">{aboutUser.nick}</h2>
                    <CFollowButton props={aboutUser._id}/>
                </div>
                <div className="block">
                    <ul className="md:flex space-x-8 mb-4">
                     <li><span className="font-semibold">{aboutUser?.followers?.length ? aboutUser?.followers?.length : "0"}</span> followers</li>
                     <li><span className="font-semibold">{aboutUser?.following?.length ? aboutUser?.following?.length : "0"}</span> following</li>
                    </ul>
                </div>

                </div>

            </div>
            <div className="px-px md:px-3">
                
                    <CUserPosts/>
                
            </div>
        </div>
    )
}

const CUserItem = connect(state=>({aboutUser: state.promise?.aboutUser?.payload || {}}))(UserItem)

export default CUserItem;